# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.DataMigration.V1.Model.ApplyJobDetails do
  @moduledoc """
  Details regarding an Apply background job.

  ## Attributes

  *   `connectionProfile` (*type:* `String.t`, *default:* `nil`) - Output only. The connection profile which was used for the apply job.
  *   `filter` (*type:* `String.t`, *default:* `nil`) - Output only. AIP-160 based filter used to specify the entities to apply
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :connectionProfile => String.t() | nil,
          :filter => String.t() | nil
        }

  field(:connectionProfile)
  field(:filter)
end

defimpl Poison.Decoder, for: GoogleApi.DataMigration.V1.Model.ApplyJobDetails do
  def decode(value, options) do
    GoogleApi.DataMigration.V1.Model.ApplyJobDetails.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.DataMigration.V1.Model.ApplyJobDetails do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
