# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.DataMigration.V1.Model.BinaryLogParser do
  @moduledoc """
  Configuration to use Binary Log Parser CDC technique.

  ## Attributes

  *   `logFileDirectories` (*type:* `GoogleApi.DataMigration.V1.Model.LogFileDirectories.t`, *default:* `nil`) - Use Oracle directories.
  *   `oracleAsmLogFileAccess` (*type:* `GoogleApi.DataMigration.V1.Model.OracleAsmLogFileAccess.t`, *default:* `nil`) - Use Oracle ASM.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :logFileDirectories => GoogleApi.DataMigration.V1.Model.LogFileDirectories.t() | nil,
          :oracleAsmLogFileAccess =>
            GoogleApi.DataMigration.V1.Model.OracleAsmLogFileAccess.t() | nil
        }

  field(:logFileDirectories, as: GoogleApi.DataMigration.V1.Model.LogFileDirectories)
  field(:oracleAsmLogFileAccess, as: GoogleApi.DataMigration.V1.Model.OracleAsmLogFileAccess)
end

defimpl Poison.Decoder, for: GoogleApi.DataMigration.V1.Model.BinaryLogParser do
  def decode(value, options) do
    GoogleApi.DataMigration.V1.Model.BinaryLogParser.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.DataMigration.V1.Model.BinaryLogParser do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
