# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.DataMigration.V1.Model.ConvertRowIdToColumn do
  @moduledoc """
  Options to configure rule type ConvertROWIDToColumn. The rule is used to add column rowid to destination tables based on an Oracle rowid function/property. The rule filter field can refer to one or more entities. The rule scope can be one of: Table. This rule requires additional filter to be specified beyond the basic rule filter field, which is whether or not to work on tables which already have a primary key defined.

  ## Attributes

  *   `onlyIfNoPrimaryKey` (*type:* `boolean()`, *default:* `nil`) - Required. Only work on tables without primary key defined
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :onlyIfNoPrimaryKey => boolean() | nil
        }

  field(:onlyIfNoPrimaryKey)
end

defimpl Poison.Decoder, for: GoogleApi.DataMigration.V1.Model.ConvertRowIdToColumn do
  def decode(value, options) do
    GoogleApi.DataMigration.V1.Model.ConvertRowIdToColumn.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.DataMigration.V1.Model.ConvertRowIdToColumn do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
