# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.DataMigration.V1.Model.DescribeDatabaseEntitiesResponse do
  @moduledoc """
  Response message for 'DescribeDatabaseEntities' request.

  ## Attributes

  *   `databaseEntities` (*type:* `list(GoogleApi.DataMigration.V1.Model.DatabaseEntity.t)`, *default:* `nil`) - The list of database entities for the conversion workspace.
  *   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - A token which can be sent as `page_token` to retrieve the next page. If this field is omitted, there are no subsequent pages.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :databaseEntities => list(GoogleApi.DataMigration.V1.Model.DatabaseEntity.t()) | nil,
          :nextPageToken => String.t() | nil
        }

  field(:databaseEntities, as: GoogleApi.DataMigration.V1.Model.DatabaseEntity, type: :list)
  field(:nextPageToken)
end

defimpl Poison.Decoder, for: GoogleApi.DataMigration.V1.Model.DescribeDatabaseEntitiesResponse do
  def decode(value, options) do
    GoogleApi.DataMigration.V1.Model.DescribeDatabaseEntitiesResponse.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.DataMigration.V1.Model.DescribeDatabaseEntitiesResponse do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
