# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.DataMigration.V1.Model.FilterTableColumns do
  @moduledoc """
  Options to configure rule type FilterTableColumns. The rule is used to filter the list of columns to include or exclude from a table. The rule filter field can refer to one entity. The rule scope can be: Table Only one of the two lists can be specified for the rule.

  ## Attributes

  *   `excludeColumns` (*type:* `list(String.t)`, *default:* `nil`) - Optional. List of columns to be excluded for a particular table.
  *   `includeColumns` (*type:* `list(String.t)`, *default:* `nil`) - Optional. List of columns to be included for a particular table.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :excludeColumns => list(String.t()) | nil,
          :includeColumns => list(String.t()) | nil
        }

  field(:excludeColumns, type: :list)
  field(:includeColumns, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.DataMigration.V1.Model.FilterTableColumns do
  def decode(value, options) do
    GoogleApi.DataMigration.V1.Model.FilterTableColumns.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.DataMigration.V1.Model.FilterTableColumns do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
