# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.DataMigration.V1.Model.ForwardSshTunnelConnectivity do
  @moduledoc """
  Forward SSH Tunnel connectivity.

  ## Attributes

  *   `hostname` (*type:* `String.t`, *default:* `nil`) - Required. Hostname for the SSH tunnel.
  *   `password` (*type:* `String.t`, *default:* `nil`) - Input only. SSH password.
  *   `port` (*type:* `integer()`, *default:* `nil`) - Port for the SSH tunnel, default value is 22.
  *   `privateKey` (*type:* `String.t`, *default:* `nil`) - Input only. SSH private key.
  *   `username` (*type:* `String.t`, *default:* `nil`) - Required. Username for the SSH tunnel.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :hostname => String.t() | nil,
          :password => String.t() | nil,
          :port => integer() | nil,
          :privateKey => String.t() | nil,
          :username => String.t() | nil
        }

  field(:hostname)
  field(:password)
  field(:port)
  field(:privateKey)
  field(:username)
end

defimpl Poison.Decoder, for: GoogleApi.DataMigration.V1.Model.ForwardSshTunnelConnectivity do
  def decode(value, options) do
    GoogleApi.DataMigration.V1.Model.ForwardSshTunnelConnectivity.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.DataMigration.V1.Model.ForwardSshTunnelConnectivity do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
