# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.DataMigration.V1.Model.OracleAsmConfig do
  @moduledoc """
  Configuration for Oracle Automatic Storage Management (ASM) connection.

  ## Attributes

  *   `asmService` (*type:* `String.t`, *default:* `nil`) - Required. ASM service name for the Oracle ASM connection.
  *   `hostname` (*type:* `String.t`, *default:* `nil`) - Required. Hostname for the Oracle ASM connection.
  *   `password` (*type:* `String.t`, *default:* `nil`) - Required. Input only. Password for the Oracle ASM connection.
  *   `passwordSet` (*type:* `boolean()`, *default:* `nil`) - Output only. Indicates whether a new password is included in the request.
  *   `port` (*type:* `integer()`, *default:* `nil`) - Required. Port for the Oracle ASM connection.
  *   `ssl` (*type:* `GoogleApi.DataMigration.V1.Model.SslConfig.t`, *default:* `nil`) - Optional. SSL configuration for the Oracle connection.
  *   `username` (*type:* `String.t`, *default:* `nil`) - Required. Username for the Oracle ASM connection.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :asmService => String.t() | nil,
          :hostname => String.t() | nil,
          :password => String.t() | nil,
          :passwordSet => boolean() | nil,
          :port => integer() | nil,
          :ssl => GoogleApi.DataMigration.V1.Model.SslConfig.t() | nil,
          :username => String.t() | nil
        }

  field(:asmService)
  field(:hostname)
  field(:password)
  field(:passwordSet)
  field(:port)
  field(:ssl, as: GoogleApi.DataMigration.V1.Model.SslConfig)
  field(:username)
end

defimpl Poison.Decoder, for: GoogleApi.DataMigration.V1.Model.OracleAsmConfig do
  def decode(value, options) do
    GoogleApi.DataMigration.V1.Model.OracleAsmConfig.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.DataMigration.V1.Model.OracleAsmConfig do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
