# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.DataMigration.V1.Model.OracleToPostgresConfig do
  @moduledoc """
  Configuration for heterogeneous **Oracle to Cloud SQL for PostgreSQL** and **Oracle to AlloyDB for PostgreSQL** migrations.

  ## Attributes

  *   `oracleSourceConfig` (*type:* `GoogleApi.DataMigration.V1.Model.OracleSourceConfig.t`, *default:* `nil`) - Optional. Configuration for Oracle source.
  *   `postgresDestinationConfig` (*type:* `GoogleApi.DataMigration.V1.Model.PostgresDestinationConfig.t`, *default:* `nil`) - Optional. Configuration for Postgres destination.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :oracleSourceConfig => GoogleApi.DataMigration.V1.Model.OracleSourceConfig.t() | nil,
          :postgresDestinationConfig =>
            GoogleApi.DataMigration.V1.Model.PostgresDestinationConfig.t() | nil
        }

  field(:oracleSourceConfig, as: GoogleApi.DataMigration.V1.Model.OracleSourceConfig)

  field(:postgresDestinationConfig, as: GoogleApi.DataMigration.V1.Model.PostgresDestinationConfig)
end

defimpl Poison.Decoder, for: GoogleApi.DataMigration.V1.Model.OracleToPostgresConfig do
  def decode(value, options) do
    GoogleApi.DataMigration.V1.Model.OracleToPostgresConfig.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.DataMigration.V1.Model.OracleToPostgresConfig do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
