# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.DataMigration.V1.Model.SeedConversionWorkspaceRequest do
  @moduledoc """
  Request message for 'SeedConversionWorkspace' request.

  ## Attributes

  *   `autoCommit` (*type:* `boolean()`, *default:* `nil`) - Should the conversion workspace be committed automatically after the seed operation.
  *   `destinationConnectionProfile` (*type:* `String.t`, *default:* `nil`) - Optional. Fully qualified (Uri) name of the destination connection profile.
  *   `sourceConnectionProfile` (*type:* `String.t`, *default:* `nil`) - Optional. Fully qualified (Uri) name of the source connection profile.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :autoCommit => boolean() | nil,
          :destinationConnectionProfile => String.t() | nil,
          :sourceConnectionProfile => String.t() | nil
        }

  field(:autoCommit)
  field(:destinationConnectionProfile)
  field(:sourceConnectionProfile)
end

defimpl Poison.Decoder, for: GoogleApi.DataMigration.V1.Model.SeedConversionWorkspaceRequest do
  def decode(value, options) do
    GoogleApi.DataMigration.V1.Model.SeedConversionWorkspaceRequest.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.DataMigration.V1.Model.SeedConversionWorkspaceRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
