# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.DataMigration.V1.Model.SourceNumericFilter do
  @moduledoc """
  Filter for fixed point number data types such as NUMERIC/NUMBER

  ## Attributes

  *   `numericFilterOption` (*type:* `String.t`, *default:* `nil`) - Required. Enum to set the option defining the datatypes numeric filter has to be applied to
  *   `sourceMaxPrecisionFilter` (*type:* `integer()`, *default:* `nil`) - Optional. The filter will match columns with precision smaller than or equal to this number.
  *   `sourceMaxScaleFilter` (*type:* `integer()`, *default:* `nil`) - Optional. The filter will match columns with scale smaller than or equal to this number.
  *   `sourceMinPrecisionFilter` (*type:* `integer()`, *default:* `nil`) - Optional. The filter will match columns with precision greater than or equal to this number.
  *   `sourceMinScaleFilter` (*type:* `integer()`, *default:* `nil`) - Optional. The filter will match columns with scale greater than or equal to this number.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :numericFilterOption => String.t() | nil,
          :sourceMaxPrecisionFilter => integer() | nil,
          :sourceMaxScaleFilter => integer() | nil,
          :sourceMinPrecisionFilter => integer() | nil,
          :sourceMinScaleFilter => integer() | nil
        }

  field(:numericFilterOption)
  field(:sourceMaxPrecisionFilter)
  field(:sourceMaxScaleFilter)
  field(:sourceMinPrecisionFilter)
  field(:sourceMinScaleFilter)
end

defimpl Poison.Decoder, for: GoogleApi.DataMigration.V1.Model.SourceNumericFilter do
  def decode(value, options) do
    GoogleApi.DataMigration.V1.Model.SourceNumericFilter.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.DataMigration.V1.Model.SourceNumericFilter do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
