# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.DataMigration.V1.Model.SqlServerDatabaseBackup do
  @moduledoc """
  Specifies the backup details for a single database in Cloud Storage for homogeneous migration to Cloud SQL for SQL Server.

  ## Attributes

  *   `database` (*type:* `String.t`, *default:* `nil`) - Required. Name of a SQL Server database for which to define backup configuration.
  *   `encryptionOptions` (*type:* `GoogleApi.DataMigration.V1.Model.SqlServerEncryptionOptions.t`, *default:* `nil`) - Optional. Encryption settings for the database. Required if provided database backups are encrypted. Encryption settings include path to certificate, path to certificate private key, and key password.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :database => String.t() | nil,
          :encryptionOptions =>
            GoogleApi.DataMigration.V1.Model.SqlServerEncryptionOptions.t() | nil
        }

  field(:database)
  field(:encryptionOptions, as: GoogleApi.DataMigration.V1.Model.SqlServerEncryptionOptions)
end

defimpl Poison.Decoder, for: GoogleApi.DataMigration.V1.Model.SqlServerDatabaseBackup do
  def decode(value, options) do
    GoogleApi.DataMigration.V1.Model.SqlServerDatabaseBackup.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.DataMigration.V1.Model.SqlServerDatabaseBackup do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
