# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.DataMigration.V1.Model.SynonymEntity do
  @moduledoc """
  Synonym's parent is a schema.

  ## Attributes

  *   `customFeatures` (*type:* `map()`, *default:* `nil`) - Custom engine specific features.
  *   `sourceEntity` (*type:* `String.t`, *default:* `nil`) - The name of the entity for which the synonym is being created (the source).
  *   `sourceType` (*type:* `String.t`, *default:* `nil`) - The type of the entity for which the synonym is being created (usually a table or a sequence).
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :customFeatures => map() | nil,
          :sourceEntity => String.t() | nil,
          :sourceType => String.t() | nil
        }

  field(:customFeatures, type: :map)
  field(:sourceEntity)
  field(:sourceType)
end

defimpl Poison.Decoder, for: GoogleApi.DataMigration.V1.Model.SynonymEntity do
  def decode(value, options) do
    GoogleApi.DataMigration.V1.Model.SynonymEntity.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.DataMigration.V1.Model.SynonymEntity do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
